/**
 *  Hyper Operating System V4 Advance
 *
 * @file  alc_hep.c
 * @brief %jp{q[vփԋp}%en{memory free}
 *
 * Copyright (C) 1998-2006 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */



#include "core/hep.h"



/** %jp{̉} */
void _kernel_fre_hep(
		_KERNEL_T_HEPCB *pk_hepcb,
		VP             ptr)
{
	_KERNEL_T_HEPBLK *mblk;
	_KERNEL_T_HEPBLK *mblktmp;
	_KERNEL_T_HEPBLK *mblknext;

	/* %jp{|C^͈̓`FbN} */
	if ( ptr < (VP)pk_hepcb->base || ptr >= (VP)((UB*)pk_hepcb->base + pk_hepcb->heapsz) )
	{
		return;
	}

	/* %jp{ubNʒu擾} */
	mblk = (_KERNEL_T_HEPBLK *)((UB *)ptr - _KERNEL_HEP_BLKSIZE);

	/* %jp{p[^[`FbN} */
	if ( mblk->flag != _KERNEL_HEP_USING )	/* %jp{gpŖ} */
	{
		return;
	}

	/* %jp{tO𖢎gpɐݒ} */
	mblk->flag = _KERNEL_HEP_FREE;
	
	/* %jp{̃ubN`FbN} */
	mblktmp = (_KERNEL_T_HEPBLK *)((UB *)ptr + mblk->size);
	if ( mblktmp->flag == _KERNEL_HEP_FREE )
	{
		/* %jp{̃ubNgpȂ猋} */
		mblknext = (_KERNEL_T_HEPBLK *)((UB *)mblktmp + mblktmp->size + _KERNEL_HEP_BLKSIZE);
		mblknext->prev = mblk;
		mblk->size += mblktmp->size + _KERNEL_HEP_BLKSIZE;
	}

	/* %jp{ÕubN`FbN} */
	if ( mblk->prev != NULL )
	{
		mblktmp = mblk->prev;
		if ( mblktmp->flag == _KERNEL_HEP_FREE )
		{
			/* %jp{ÕubNgpȂ猋} */
			mblknext = (_KERNEL_T_HEPBLK *)((UB *)mblk + mblk->size + _KERNEL_HEP_BLKSIZE);
			mblknext->prev = mblktmp;
			mblktmp->size += mblk->size + _KERNEL_HEP_BLKSIZE;
		}
	}
}



/* end of file */
